diff -crN nakedmudv1.5/src/character.c nakedmudv2.0/src/character.c
*** nakedmudv1.5/src/character.c	2010-11-01 15:54:17.000000000 -0500
--- nakedmudv2.0/src/character.c	2010-11-01 15:54:18.000000000 -0500
***************
*** 91,97 ****
  struct char_data {
    // data for PCs only
    char                 * password;
-   bitvector_t            prfs;  
    room_vnum              loadroom;
    int                    imm_invis;
  
--- 91,96 ----
***************
*** 105,111 ****
    SOCKET_DATA          * socket;
    ROOM_DATA            * room;
    OBJ_DATA             * furniture;
!   char                 * desc;
    char                 * name;
    int                    level;
    int                    sex;
--- 104,110 ----
    SOCKET_DATA          * socket;
    ROOM_DATA            * room;
    OBJ_DATA             * furniture;
!   BUFFER               * desc;
    char                 * name;
    int                    level;
    int                    sex;
***************
*** 113,118 ****
--- 112,118 ----
  
    LIST                 * inventory;
    HASHTABLE            * auxiliary_data;
+   BITVECTOR            * prfs;
  
    // data for NPCs only
    dialog_vnum            dialog;
***************
*** 129,135 ****
    bzero(ch, sizeof(*ch));
  
    ch->password      = strdup("");
-   ch->prfs          = 0;
    ch->imm_invis     = 0;
  
    ch->loadroom      = NOWHERE;
--- 129,134 ----
***************
*** 140,146 ****
    ch->room          = NULL;
    ch->furniture     = NULL;
    ch->socket        = NULL;
!   ch->desc          = strdup("");
    ch->name          = strdup("");
    ch->level         = LEVEL_PLAYER;
    ch->sex           = SEX_NEUTRAL;
--- 139,145 ----
    ch->room          = NULL;
    ch->furniture     = NULL;
    ch->socket        = NULL;
!   ch->desc          = newBuffer(1);
    ch->name          = strdup("");
    ch->level         = LEVEL_PLAYER;
    ch->sex           = SEX_NEUTRAL;
***************
*** 153,158 ****
--- 152,158 ----
    ch->multi_name    = strdup("");
    ch->dialog        = NOTHING;
    ch->vnum          = NOBODY;
+   ch->prfs          = bitvectorInstanceOf("char_prfs");
  
    ch->auxiliary_data = newAuxiliaryData(AUXILIARY_TYPE_CHAR);
  
***************
*** 181,208 ****
    ch->multi_name =   strdup(multi_name ? multi_name : "");
  }
  
- void         charSetBit       ( CHAR_DATA *ch, int field, int bit) {
-   if(field == BITFIELD_PRFS)
-     SET_BIT(ch->prfs, (1 << bit));
- }
- 
- void         charRemoveBit    ( CHAR_DATA *ch, int field, int bit) {
-   if(field == BITFIELD_PRFS)
-     REMOVE_BIT(ch->prfs, (1 << bit));
- }
- 
- void         charToggleBit    ( CHAR_DATA *ch, int field, int bit) {
-   if(field == BITFIELD_PRFS)
-     TOGGLE_BIT(ch->prfs, (1 << bit));
- }
- 
- bool         charIsBitSet     ( CHAR_DATA *ch, int field, int bit) {
-   if(field == BITFIELD_PRFS && IS_SET(ch->prfs, (1 << bit)))
-     return TRUE;
- 
-   return FALSE;
- }
- 
  bool charIsNPC( CHAR_DATA *ch) {
    return (ch->uid >= START_MOB_UID);
  }
--- 181,186 ----
***************
*** 241,251 ****
  };
  
  const char  *charGetDesc      ( CHAR_DATA *ch) {
!   return ch->desc;
  }
  
! char       **charGetDescPtr   ( CHAR_DATA *ch) {
!   return &(ch->desc);
  }
  
  const char  *charGetRdesc     ( CHAR_DATA *ch) {
--- 219,229 ----
  };
  
  const char  *charGetDesc      ( CHAR_DATA *ch) {
!   return bufferString(ch->desc);
  }
  
! BUFFER      *charGetDescBuffer( CHAR_DATA *ch) {
!   return ch->desc;
  }
  
  const char  *charGetRdesc     ( CHAR_DATA *ch) {
***************
*** 273,285 ****
    return ch->position;
  };
  
- bitvector_t  charGetBits      ( CHAR_DATA *ch, int field) {
-   if(field == BITFIELD_PRFS)
-     return ch->prfs;
- 
-   return 0;
- }
- 
  BODY_DATA   *charGetBody      ( CHAR_DATA *ch) {
    return ch->body;
  }
--- 251,256 ----
***************
*** 308,313 ****
--- 279,288 ----
    return ch->imm_invis;
  }
  
+ BITVECTOR *charGetPrfs(CHAR_DATA *ch) {
+   return ch->prfs;
+ }
+ 
  void         charSetSocket    ( CHAR_DATA *ch, SOCKET_DATA *socket) {
    ch->socket = socket;
  };
***************
*** 339,346 ****
  };
  
  void         charSetDesc      ( CHAR_DATA *ch, const char *desc) {
!   if(ch->desc) free(ch->desc);
!   ch->desc = strdup(desc ? desc : "");
  };
  
  void         charSetBody      ( CHAR_DATA *ch, BODY_DATA *body) {
--- 314,321 ----
  };
  
  void         charSetDesc      ( CHAR_DATA *ch, const char *desc) {
!   bufferClear(ch->desc);
!   bufferCat(ch->desc, (desc ? desc : ""));
  };
  
  void         charSetBody      ( CHAR_DATA *ch, BODY_DATA *body) {
***************
*** 398,408 ****
  
    if(mob->password)    free(mob->password);
    if(mob->name)        free(mob->name);
!   if(mob->desc)        free(mob->desc);
    if(mob->rdesc)       free(mob->rdesc);
    if(mob->multi_rdesc) free(mob->multi_rdesc);
    if(mob->multi_name)  free(mob->multi_name);
    if(mob->keywords)    free(mob->keywords);
    deleteAuxiliaryData(mob->auxiliary_data);
  
    free(mob);
--- 373,384 ----
  
    if(mob->password)    free(mob->password);
    if(mob->name)        free(mob->name);
!   if(mob->desc)        deleteBuffer(mob->desc);
    if(mob->rdesc)       free(mob->rdesc);
    if(mob->multi_rdesc) free(mob->multi_rdesc);
    if(mob->multi_name)  free(mob->multi_name);
    if(mob->keywords)    free(mob->keywords);
+   if(mob->prfs)        deleteBitvector(mob->prfs);
    deleteAuxiliaryData(mob->auxiliary_data);
  
    free(mob);
***************
*** 423,428 ****
--- 399,405 ----
    charSetSex(mob,          read_int   (set, "sex"));
    charSetRace(mob,         read_string(set, "race"));
    charSetPassword(mob,     read_string(set, "password"));
+   bitSet(mob->prfs,        read_string(set, "prfs"));
  
    // read in PC data
    if(*charGetPassword(mob)) {
***************
*** 430,436 ****
      charSetUID(mob,        read_int   (set, "uid"));
      charSetLoadroom(mob,   read_int   (set, "loadroom"));
      charSetPos(mob,        read_int   (set, "position"));
-     mob->prfs = parse_bits(read_string(set, "prfs"));
    }
    // and NPC data
    else
--- 407,412 ----
***************
*** 459,476 ****
    store_string(set, "name",       mob->name);
    store_string(set, "keywords",   mob->keywords);
    store_string(set, "rdesc",      mob->rdesc);
!   store_string(set, "desc",       mob->desc);
    store_string(set, "multirdesc", mob->multi_rdesc);
    store_string(set, "multiname",  mob->multi_name);
    store_int   (set, "level",      mob->level);
    store_int   (set, "sex",        mob->sex);
    store_string(set, "race",       mob->race);
  
    // PC-only data
    if(!charIsNPC(mob)) {
      store_int   (set, "imm_invis",  mob->imm_invis);
      store_int   (set, "position",   mob->position);
-     store_string(set, "prfs",       write_bits(mob->prfs));
      store_string(set, "password",   mob->password);
      store_int   (set, "uid",        mob->uid);
      store_int   (set, "loadroom",   roomGetVnum(charGetRoom(mob)));
--- 435,452 ----
    store_string(set, "name",       mob->name);
    store_string(set, "keywords",   mob->keywords);
    store_string(set, "rdesc",      mob->rdesc);
!   store_string(set, "desc",       bufferString(mob->desc));
    store_string(set, "multirdesc", mob->multi_rdesc);
    store_string(set, "multiname",  mob->multi_name);
    store_int   (set, "level",      mob->level);
    store_int   (set, "sex",        mob->sex);
    store_string(set, "race",       mob->race);
+   store_string(set, "prfs",       bitvectorGetBits(mob->prfs));
  
    // PC-only data
    if(!charIsNPC(mob)) {
      store_int   (set, "imm_invis",  mob->imm_invis);
      store_int   (set, "position",   mob->position);
      store_string(set, "password",   mob->password);
      store_int   (set, "uid",        mob->uid);
      store_int   (set, "loadroom",   roomGetVnum(charGetRoom(mob)));
***************
*** 500,505 ****
--- 476,482 ----
    charSetRace       (to, charGetRace(from));
    charSetBody       (to, bodyCopy(charGetBody(from)));
    charSetImmInvis   (to, charGetImmInvis(from));
+   bitvectorCopyTo   (from->prfs, to->prfs);
  
    auxiliaryDataCopyTo(from->auxiliary_data, to->auxiliary_data);
  }
diff -crN nakedmudv1.5/src/character.d nakedmudv2.0/src/character.d
*** nakedmudv1.5/src/character.d	1969-12-31 18:00:00.000000000 -0600
--- nakedmudv2.0/src/character.d	2010-11-01 15:54:18.000000000 -0500
***************
*** 0 ****
--- 1,3 ----
+ character.d character.o: character.c mud.h wrapsock.h property_table.h list.h map.h \
+   hashtable.h set.h buffer.h bitvector.h utils.h body.h races.h handler.h \
+   auxiliary.h storage.h room.h character.h
diff -crN nakedmudv1.5/src/character.h nakedmudv2.0/src/character.h
*** nakedmudv1.5/src/character.h	2010-11-01 15:54:17.000000000 -0500
--- nakedmudv2.0/src/character.h	2010-11-01 15:54:18.000000000 -0500
***************
*** 49,54 ****
--- 49,58 ----
  __attribute__ ((format (printf, 2, 3)));
  void  send_to_list          (LIST *list, const char *format, ...) 
  __attribute__ ((format (printf, 2, 3)));
+ void send_around_char(CHAR_DATA *ch, bool hide_nosee, const char *format, ...) 
+ __attribute__ ((format (printf, 3, 4)));
+ void send_to_level(int level, const char *format, ...) 
+ __attribute__ ((format (printf, 2, 3)));
  
  
  //*****************************************************************************
***************
*** 66,74 ****
  const char  *charGetMultiName ( CHAR_DATA *ch);
  int          charGetLevel     ( CHAR_DATA *ch);
  int          charGetSex       ( CHAR_DATA *ch);
- bitvector_t  charGetBits      ( CHAR_DATA *ch, int field);
  // for editing with the text editor
! char       **charGetDescPtr   ( CHAR_DATA *ch);
  LIST        *charGetInventory ( CHAR_DATA *ch);
  BODY_DATA   *charGetBody      ( CHAR_DATA *ch);
  const char  *charGetRace      ( CHAR_DATA *ch);
--- 70,77 ----
  const char  *charGetMultiName ( CHAR_DATA *ch);
  int          charGetLevel     ( CHAR_DATA *ch);
  int          charGetSex       ( CHAR_DATA *ch);
  // for editing with the text editor
! BUFFER      *charGetDescBuffer( CHAR_DATA *ch);
  LIST        *charGetInventory ( CHAR_DATA *ch);
  BODY_DATA   *charGetBody      ( CHAR_DATA *ch);
  const char  *charGetRace      ( CHAR_DATA *ch);
***************
*** 78,83 ****
--- 81,88 ----
  int          charGetPos       ( CHAR_DATA *ch);
  void        *charGetAuxiliaryData(const CHAR_DATA *ch, const char *name);
  int          charGetImmInvis  ( CHAR_DATA *ch);
+ BITVECTOR   *charGetPrfs      ( CHAR_DATA *ch);
+ 
  
  void         charSetSocket    ( CHAR_DATA *ch, SOCKET_DATA *socket);
  void         charSetRoom      ( CHAR_DATA *ch, ROOM_DATA *room);
***************
*** 116,140 ****
  
  //*****************************************************************************
  //
- // Bitfields and their bits
- //
- //*****************************************************************************
- void         charToggleBit    ( CHAR_DATA *ch, int field, int bit);
- void         charSetBit       ( CHAR_DATA *ch, int field, int bit);
- void         charRemoveBit    ( CHAR_DATA *ch, int field, int bit);
- bool         charIsBitSet     ( CHAR_DATA *ch, int field, int bit);
- 
- // hmmm... we should really replace bitvectors with something a bit
- // more amenable to extention by modules. Perhaps use char_vars?
- #define BITFIELD_PRFS             0
- 
- #define PRF_BUILDWALK             0    // (1 << 0)
- #define PRF_MAPWALK               1    // (1 << 1)
- 
- 
- 
- //*****************************************************************************
- //
  // Sexes
  //
  //*****************************************************************************
--- 121,126 ----
diff -crN nakedmudv1.5/src/char_vars/char_vars.d nakedmudv2.0/src/char_vars/char_vars.d
*** nakedmudv1.5/src/char_vars/char_vars.d	1969-12-31 18:00:00.000000000 -0600
--- nakedmudv2.0/src/char_vars/char_vars.d	2010-11-01 15:54:18.000000000 -0500
***************
*** 0 ****
--- 1,3 ----
+ char_vars/char_vars.d char_vars/char_vars.o: char_vars/char_vars.c mud.h wrapsock.h property_table.h \
+   list.h map.h hashtable.h set.h buffer.h bitvector.h utils.h character.h \
+   storage.h auxiliary.h char_vars/char_vars.h
diff -crN nakedmudv1.5/src/cmd_admin.c nakedmudv2.0/src/cmd_admin.c
*** nakedmudv1.5/src/cmd_admin.c	2010-11-01 15:54:17.000000000 -0500
--- nakedmudv2.0/src/cmd_admin.c	2010-11-01 15:54:18.000000000 -0500
***************
*** 29,34 ****
--- 29,109 ----
  
  
  //
+ // Perform a command multiple times
+ //
+ COMMAND(cmd_repeat) {
+   if(!arg || !*arg) {
+     send_to_char(ch, "What did you want to repeat, and how many times?\r\n");
+     return;
+   }
+ 
+   // how many times should we repeat?
+   char rep_buf[SMALL_BUFFER];
+   arg = one_arg(arg, rep_buf);
+   int  repeats = atoi(rep_buf);
+ 
+   // no command to delay
+   if(!*arg)
+     send_to_char(ch, "What command did you want to repeat?\r\n");
+   else if(repeats < 1)
+     send_to_char(ch, "You can only repeat commands a positive amounts of time.\r\n");
+   else {
+     int i;
+     // now, do the repeating
+     for(i = 0; i < repeats; i++)
+       do_cmd(ch, arg, TRUE, TRUE);
+   }
+ }
+ 
+ 
+ //
+ // Perform a command at another room or person
+ //
+ COMMAND(cmd_at) {
+   if(!arg || !*arg) {
+     send_to_char(ch, "Do what where?\r\n");
+     return;
+   }
+ 
+   // how many times should we repeat?
+   char where[SMALL_BUFFER];
+   arg = one_arg(arg, where);
+ 
+   // no command to delay
+   if(!*arg)
+     send_to_char(ch, "What were you trying to do, and where?\r\n");
+   else {
+     // first, are we trying to do this at a room vnum?
+     ROOM_DATA *room = NULL;
+ 
+     // are we looking for a vnum?
+     if(isdigit(*where))
+       room = worldGetRoom(gameworld, atoi(where));
+ 
+     // no room? Maybe its the name of someone
+     if(room == NULL) {
+       CHAR_DATA *tgt = generic_find(ch, where, FIND_TYPE_CHAR,
+ 				    FIND_SCOPE_ALL | FIND_SCOPE_VISIBLE,
+ 				    FALSE, NULL);
+       if(tgt != NULL)
+ 	room = charGetRoom(tgt);
+     }
+ 
+     if(room == NULL)
+       send_to_char(ch, "Where were you trying to do that?\r\n");
+     else {
+       ROOM_DATA *old_room = charGetRoom(ch);
+       char_from_room(ch);
+       char_to_room(ch, room);
+       do_cmd(ch, arg, TRUE, TRUE);
+       char_from_room(ch);
+       char_to_room(ch, old_room);
+     }
+   }
+ }
+ 
+ 
+ //
  // Go to a specific room, object, or character in the game. Rooms are referenced
  // by vnum. Everything else is referenced by name.
  //   usage: goto [thing]
***************
*** 122,174 ****
  // Perform a copyover
  //
  COMMAND(cmd_copyover) { 
!   FILE *fp;
!   SOCKET_DATA *dsock;
!   char buf[100];
!   char control_buf[20];
!   char port_buf[20];
!   LIST_ITERATOR *sock_i = newListIterator(socket_list);
!   
!   if ((fp = fopen(COPYOVER_FILE, "w")) == NULL)
!   {
!     text_to_char(ch, "Copyover file not writeable, aborted.\n\r");
!     return;
!   }
! 
!   sprintf(buf, "\n\r <*>            The world starts spinning             <*>\n\r");
! 
!   /* For each playing descriptor, save its state */
!   //  for (dsock = dsock_list; dsock ; dsock = dsock_next)
!   ITERATE_LIST(dsock, sock_i) {
!     compressEnd(dsock, dsock->compressing, FALSE);
!     if (dsock->state != STATE_PLAYING) {
!       text_to_socket(dsock, "\r\nSorry, we are rebooting. Come back in a few minutes.\r\n");
!       close_socket(dsock, FALSE);
!     }
!     else {
!       fprintf(fp, "%d %s %s\n",
! 	      dsock->control, charGetName(dsock->player), dsock->hostname);
!       /* save the player */
!       save_player(dsock->player);
!       text_to_socket(dsock, buf);
!     }
!   }
!   deleteListIterator(sock_i);
!   
!   fprintf (fp, "-1\n");
!   fclose (fp);
! 
! 
!   /* close any pending sockets */
!   recycle_sockets();
!   
!   /* exec - descriptors are inherited */
!   sprintf(control_buf, "%d", control);
!   sprintf(port_buf, "%d", mudport);
!   execl(EXE_FILE, "NakedMud", "-copyover", control_buf, port_buf, NULL);
! 
!   /* Failed - sucessful exec will not return */
!   text_to_char(ch, "Copyover FAILED!\n\r");
  }
  
  
--- 197,203 ----
  // Perform a copyover
  //
  COMMAND(cmd_copyover) { 
!   do_copyover(ch);
  }
  
  
diff -crN nakedmudv1.5/src/cmd_admin.d nakedmudv2.0/src/cmd_admin.d
*** nakedmudv1.5/src/cmd_admin.d	1969-12-31 18:00:00.000000000 -0600
--- nakedmudv2.0/src/cmd_admin.d	2010-11-01 15:54:18.000000000 -0500
***************
*** 0 ****
--- 1,3 ----
+ cmd_admin.d cmd_admin.o: cmd_admin.c mud.h wrapsock.h property_table.h list.h map.h \
+   hashtable.h set.h buffer.h bitvector.h world.h inform.h character.h \
+   handler.h utils.h log.h socket.h save.h event.h action.h storage.h
diff -crN nakedmudv1.5/src/cmd_builder.c nakedmudv2.0/src/cmd_builder.c
*** nakedmudv1.5/src/cmd_builder.c	2010-11-01 15:54:17.000000000 -0500
--- nakedmudv2.0/src/cmd_builder.c	2010-11-01 15:54:18.000000000 -0500
***************
*** 20,40 ****
  #include "inform.h"
  #include "utils.h"
  #include "races.h"
- #include "items.h"
  #include "dialog.h"
  
! // optional modules
! #ifdef MODULE_SCRIPTS
  #include "scripts/script.h"
  #include "scripts/script_set.h"
! #endif
  
  
  //
  // Try to dig a special exit in a specific direction. Unlike cmd_dig,
  // specdig does not link the room we're digging to, back to us, since
  // we can't really figure out what the opposite direction is
- //
  void try_specdig(CHAR_DATA *ch, const char *dir, room_vnum to) {
    if(roomGetExitSpecial(charGetRoom(ch), dir))
      send_to_char(ch, "You must fill in the %s exit before you dig a new exit.\r\n", dir);
--- 20,42 ----
  #include "inform.h"
  #include "utils.h"
  #include "races.h"
  #include "dialog.h"
  
! 
! 
! //*****************************************************************************
! // mandatory modules
! //*****************************************************************************
  #include "scripts/script.h"
  #include "scripts/script_set.h"
! #include "items/items.h"
! 
  
  
  //
  // Try to dig a special exit in a specific direction. Unlike cmd_dig,
  // specdig does not link the room we're digging to, back to us, since
  // we can't really figure out what the opposite direction is
  void try_specdig(CHAR_DATA *ch, const char *dir, room_vnum to) {
    if(roomGetExitSpecial(charGetRoom(ch), dir))
      send_to_char(ch, "You must fill in the %s exit before you dig a new exit.\r\n", dir);
***************
*** 52,58 ****
  // Try to fill in a special exit in a specific direction. Unlike cmd_dig,
  // specdig does not fill in the exit on the other side, since we can't
  // really figure out what the opposite direction is.
- //
  void try_specfill(CHAR_DATA *ch, const char *dir) {
    if(!roomGetExitSpecial(charGetRoom(ch), dir))
      send_to_char(ch, "There doesn't seem to be an exit in that direction.\r\n");
--- 54,59 ----
***************
*** 193,204 ****
  	char_to_game(mob);
  	char_to_room(mob, charGetRoom(ch));
  
- #ifdef MODULE_SCRIPTS
  	// check for initialization scripts
  	try_scripts(SCRIPT_TYPE_INIT,
  		    mob, SCRIPTOR_CHAR,
  		    NULL, NULL, charGetRoom(mob), NULL, NULL, 0);
- #endif
        }
      }
  
--- 194,203 ----
***************
*** 212,223 ****
  	obj_to_game(obj);
  	obj_to_char(obj, ch);
  
- #ifdef MODULE_SCRIPTS
  	// check for initialization scripts
  	try_scripts(SCRIPT_TYPE_INIT,
  		    obj, SCRIPTOR_OBJ,
  		    ch, NULL, charGetRoom(ch), NULL, NULL, 0);
- #endif
        }
      }
    }
--- 211,220 ----
***************
*** 319,343 ****
  }
  
  
  //*****************************************************************************
  //
  // Functions for listing different types of data (zones, mobs, objs, etc...)
  //
  //*****************************************************************************
  
  //
  // Generic xxxlist for builders. If the thing to list doesn't have any types
! // (e.g. dialogs) then typer and type_namer can both be NULL
! //
  void do_list(CHAR_DATA *ch, 
! 	     void *getter, void *namer, 
! 	     void *typer,  void *type_namer, 
! 	     const char *datatype, char *arg) {
!   int (* type_func)(void *)              = typer;
!   const char *(* type_naming_func)(int)  = type_namer;
!   const char *(* naming_func)(void *)    = namer;
!   void *(* get_func)(void *, int)        = getter;
!   ZONE_DATA *zone                        = NULL;
    
    if(!arg || !*arg)
      zone = worldZoneBounding(gameworld, roomGetVnum(charGetRoom(ch)));
--- 316,359 ----
  }
  
  
+ //
+ // toggle buildwalking on and off
+ //
+ COMMAND(cmd_buildwalk) {
+   bitToggle(charGetPrfs(ch), "buildwalk");
+   send_to_char(ch, "Buildwalk %s.\r\n",
+ 	       (bitIsOneSet(charGetPrfs(ch), "buildwalk") ? "on":"off"));
+ }
+ 
+ 
  //*****************************************************************************
  //
  // Functions for listing different types of data (zones, mobs, objs, etc...)
  //
  //*****************************************************************************
+ const char *charGetListType(CHAR_DATA *ch) {
+   return charGetRace(ch);
+ }
+ 
+ const char *roomGetListType(ROOM_DATA *room) {
+   return terrainGetName(roomGetTerrain(room));
+ }
+ 
+ const char *scriptGetListType(SCRIPT_DATA *script) {
+   return scriptTypeName(scriptGetType(script));
+ }
+ 
  
  //
  // Generic xxxlist for builders. If the thing to list doesn't have any types
! // (e.g. dialogs) then type_namer can be NULL.
  void do_list(CHAR_DATA *ch, 
! 	     void *getter, void *namer, void *type_namer, 
! 	     const char *datatype, const char *arg) {
!   const char *(* type_naming_func)(void *)  = type_namer;
!   const char *(* naming_func)(void *)       = namer;
!   void *(* get_func)(void *, int)           = getter;
!   ZONE_DATA *zone                           = NULL;
    
    if(!arg || !*arg)
      zone = worldZoneBounding(gameworld, roomGetVnum(charGetRoom(ch)));
***************
*** 351,394 ****
      send_to_char(ch,
  " {wVnum  Name                                                                %s\r\n"
  "{b-------------------------------------------------------------------------------{n\r\n",
! 		 ((type_func == NULL || type_naming_func == NULL) ? "" : "Type")
! 		 );
      for(vnum = zoneGetMinBound(zone); vnum <= zoneGetMaxBound(zone); vnum++) {
        void *data = get_func(zone, vnum);
        if(data != NULL)
  	send_to_char(ch, "{y[{c%4d{y] {c%-50s{w%22s{n\r\n", 
  		     vnum, naming_func(data), 
! 		     ((type_func == NULL || type_naming_func == NULL) ? "" :
! 		      type_naming_func(type_func(data))));
      }
    }
  }
  
- 
- #ifdef MODULE_SCRIPTS
  COMMAND(cmd_sclist) {
!   do_list(ch, zoneGetScript, scriptGetName, scriptGetType, scriptTypeName,
! 	  "scripts", arg);
  }
- #endif
  
  COMMAND(cmd_rlist) {
!   do_list(ch, zoneGetRoom, roomGetName, roomGetTerrain, terrainGetName,
! 	  "rooms", arg);
  }
  
  COMMAND(cmd_mlist) {
!   //  do_list(ch, zoneGetMob, charGetName, charGetRace, raceGetName,
!   //	  "mobs", arg);
  }
  
  COMMAND(cmd_olist) {
!   do_list(ch, zoneGetObj, objGetName, objGetType, itemGetType,
! 	  "objects", arg);
  }
  
  COMMAND(cmd_dlist) {
!   do_list(ch, zoneGetDialog, dialogGetName, NULL, NULL, "dialogs", arg);
  }
  
  int zone_comparator(ZONE_DATA *zone1, ZONE_DATA *zone2) {
--- 367,401 ----
      send_to_char(ch,
  " {wVnum  Name                                                                %s\r\n"
  "{b-------------------------------------------------------------------------------{n\r\n",
! 		 (type_naming_func == NULL ? "" : "Type"));
      for(vnum = zoneGetMinBound(zone); vnum <= zoneGetMaxBound(zone); vnum++) {
        void *data = get_func(zone, vnum);
        if(data != NULL)
  	send_to_char(ch, "{y[{c%4d{y] {c%-50s{w%22s{n\r\n", 
  		     vnum, naming_func(data), 
! 		     (type_naming_func == NULL ? "" : type_naming_func(data)));
      }
    }
  }
  
  COMMAND(cmd_sclist) {
!   do_list(ch, zoneGetScript, scriptGetName, scriptGetListType, "scripts", arg);
  }
  
  COMMAND(cmd_rlist) {
!   do_list(ch, zoneGetRoom, roomGetName, roomGetListType, "rooms", arg);
  }
  
  COMMAND(cmd_mlist) {
!   do_list(ch, zoneGetMob, charGetName, charGetListType, "mobs", arg);
  }
  
  COMMAND(cmd_olist) {
!   do_list(ch, zoneGetObj, objGetName, objGetTypes, "objs", arg);
  }
  
  COMMAND(cmd_dlist) {
!   do_list(ch, zoneGetDialog, dialogGetName, NULL, "dialogs", arg);
  }
  
  int zone_comparator(ZONE_DATA *zone1, ZONE_DATA *zone2) {
diff -crN nakedmudv1.5/src/cmd_builder.d nakedmudv2.0/src/cmd_builder.d
*** nakedmudv1.5/src/cmd_builder.d	1969-12-31 18:00:00.000000000 -0600
--- nakedmudv2.0/src/cmd_builder.d	2010-11-01 15:54:18.000000000 -0500
***************
*** 0 ****
--- 1,4 ----
+ cmd_builder.d cmd_builder.o: cmd_builder.c mud.h wrapsock.h property_table.h list.h \
+   map.h hashtable.h set.h buffer.h bitvector.h world.h zone.h room.h \
+   exit.h movement.h character.h object.h handler.h inform.h utils.h \
+   races.h dialog.h scripts/script.h scripts/script_set.h items/items.h
diff -crN nakedmudv1.5/src/cmd_comm.c nakedmudv2.0/src/cmd_comm.c
*** nakedmudv1.5/src/cmd_comm.c	2010-11-01 15:54:17.000000000 -0500
--- nakedmudv2.0/src/cmd_comm.c	2010-11-01 15:54:18.000000000 -0500
***************
*** 16,25 ****
  #include "dialog.h"
  
  
! // option modules
! #ifdef MODULE_SCRIPTS
  #include "scripts/script.h"
! #endif
  
  
  //
--- 16,27 ----
  #include "dialog.h"
  
  
! 
! //*****************************************************************************
! // mandatory modules
! //*****************************************************************************
  #include "scripts/script.h"
! 
  
  
  //
***************
*** 31,37 ****
  //   examples:
  //     ask bob about cats           ask bob about the topic, "cats"
  //     ask jim can I have a salad?  ask jim if you can have a salad
- //
  COMMAND(cmd_ask)
  {
    if(!arg || !*arg)
--- 33,38 ----
***************
*** 69,77 ****
  	send_to_char(ch, "{wYou ask %s%s, '%s'{n\r\n", 
  		     charGetName(tgt), (ask_about ? " about" : ""), arg);
  
- #ifdef MODULE_SCRIPTS
  	try_speech_script(ch, tgt, arg);
- #endif	
  
  	// see if the NPC has something to say in return
  	if(!try_dialog(ch, tgt, arg))
--- 70,76 ----
***************
*** 275,277 ****
--- 274,299 ----
      message(ch, NULL, NULL, NULL, FALSE, TO_WORLD, buf);
    }
  }
+ 
+ 
+ //
+ // Send a message to another character, and also make it beep
+ //
+ COMMAND(cmd_page) {
+   CHAR_DATA *tgt = NULL;
+   char name[SMALL_BUFFER];
+   arg = one_arg(arg, name);
+ 
+   if(!*name)
+     send_to_char(ch, "Page whom?\r\n");
+   else if( (tgt = generic_find(ch, name, FIND_TYPE_CHAR, 
+ 			       FIND_SCOPE_ALL | FIND_SCOPE_VISIBLE,
+ 			       FALSE, NULL)) == NULL)
+     send_to_char(ch, "Who were you looking for?\r\n");
+   else if(ch == tgt)
+     send_to_char(ch, "What did you want to let yourself know?\r\n");
+   else {
+     send_to_char(ch,  "\007\007You page %s.\r\n", see_char_as(ch, tgt));
+     send_to_char(tgt, "\007\007*%s* %s\r\n", see_char_as(tgt, ch), arg);
+   }
+ }
diff -crN nakedmudv1.5/src/cmd_comm.d nakedmudv2.0/src/cmd_comm.d
*** nakedmudv1.5/src/cmd_comm.d	1969-12-31 18:00:00.000000000 -0600
--- nakedmudv2.0/src/cmd_comm.d	2010-11-01 15:54:18.000000000 -0500
***************
*** 0 ****
--- 1,3 ----
+ cmd_comm.d cmd_comm.o: cmd_comm.c mud.h wrapsock.h property_table.h list.h map.h \
+   hashtable.h set.h buffer.h bitvector.h utils.h handler.h inform.h \
+   character.h world.h dialog.h scripts/script.h
